`timescale 1ns / 1ps
//date 2016/04/21 yokomizo
module gazou_syori(
  clk,
  rst,
  data_in_r,
  data_in_g,
  data_in_b,
  data_in_en,
  vsync,
  hsync,
  data_out_r,
  data_out_g,
  data_out_b,
  data_out_en,
  vsync_o,
  hsync_o,
  vga_r,
  vga_g,
  vga_b,
  vga_en,
  vga_hsync,
  vga_vsync,
  mode_sw,
  vga_sel
);

  input        clk;
  input        rst;
  input  [7:0] data_in_r;
  input  [7:0] data_in_g;
  input  [7:0] data_in_b;
  input        data_in_en;
  input        vsync;
  input        hsync;
  output  [7:0] data_out_r;
  output  [7:0] data_out_g;
  output  [7:0] data_out_b;
  output        data_out_en;
  output        vsync_o;
  output        hsync_o;
  output  [7:0] vga_r;
  output  [7:0] vga_g;
  output  [7:0] vga_b;
  output        vga_en;
  output        vga_vsync;
  output        vga_hsync;
  input [2:0]mode_sw;
  input vga_sel;
  
  reg  [7:0] data_out_r;
  reg  [7:0] data_out_g;
  reg  [7:0] data_out_b;
  reg        data_out_en;
  reg        vsync_o;
  reg        hsync_o;
  wire [15:0]da_gray;
  wire [7:0]maped_gray;
  
  //f[^}bsO֐
  function [7:0]map_func ;
    input [7:0] da_in;
    begin
      case(da_in)
        8'h00:map_func = 8'h00;	 
        8'h01:map_func = 8'h00;	  
        8'h02:map_func = 8'h00;	  
        8'h03:map_func = 8'h00;	  
        8'h04:map_func = 8'h00;	 
        8'h05:map_func = 8'h00;	  
        8'h06:map_func = 8'h00;	  
        8'h07:map_func = 8'h00;	  
        8'h08:map_func = 8'h00;	  
        8'h09:map_func = 8'h00;	  
        8'h0a:map_func = 8'h00;	  
        8'h0b:map_func = 8'h00;	  
        8'h0c:map_func = 8'h00; 
        8'h0d:map_func = 8'h00;	  
        8'h0e:map_func = 8'h00;	  
        8'h0f:map_func = 8'h00;	 
        8'h10:map_func = 8'h00;	 
        8'h11:map_func = 8'h00;	  
        8'h12:map_func = 8'h00;	  
        8'h13:map_func = 8'h00;	  
        8'h14:map_func = 8'h00;	 
        8'h15:map_func = 8'h00;	  
        8'h16:map_func = 8'h00;	  
        8'h17:map_func = 8'h00;	  
        8'h18:map_func = 8'h00;	  
        8'h19:map_func = 8'h00;	  
        8'h1a:map_func = 8'h00;	  
        8'h1b:map_func = 8'h00;	  
        8'h1c:map_func = 8'h00; 
        8'h1d:map_func = 8'h00;	  
        8'h1e:map_func = 8'h00;	  
        8'h1f:map_func = 8'h00;	 
        8'h20:map_func = 8'h00;	 
        8'h21:map_func = 8'h00;	  
        8'h22:map_func = 8'h00;	  
        8'h23:map_func = 8'h00;	  
        8'h24:map_func = 8'h00;	 
        8'h25:map_func = 8'h00;	  
        8'h26:map_func = 8'h00;	  
        8'h27:map_func = 8'h00;	  
        8'h28:map_func = 8'h00;	  
        8'h29:map_func = 8'h00;	  
        8'h2a:map_func = 8'h00;	  
        8'h2b:map_func = 8'h00;	  
        8'h2c:map_func = 8'h00; 
        8'h2d:map_func = 8'h00;	  
        8'h2e:map_func = 8'h00;	  
        8'h2f:map_func = 8'h00;	 
        8'h30:map_func = 8'h00;	 
        8'h31:map_func = 8'h00;	  
        8'h32:map_func = 8'h00;	  
        8'h33:map_func = 8'h00;	  
        8'h34:map_func = 8'h00;	 
        8'h35:map_func = 8'h00;	  
        8'h36:map_func = 8'h00;	  
        8'h37:map_func = 8'h00;	  
        8'h38:map_func = 8'h00;	  
        8'h39:map_func = 8'h00;	  
        8'h3a:map_func = 8'h00;	  
        8'h3b:map_func = 8'h00;	  
        8'h3c:map_func = 8'h00; 
        8'h3d:map_func = 8'h00;	  
        8'h3e:map_func = 8'h00;	  
        8'h3f:map_func = 8'h00;	 
        8'h40:map_func = 8'hff;	 
        8'h41:map_func = 8'hff;	  
        8'h42:map_func = 8'hff;	  
        8'h43:map_func = 8'hff;	  
        8'h44:map_func = 8'hff;	 
        8'h45:map_func = 8'hff;	  
        8'h46:map_func = 8'hff;	  
        8'h47:map_func = 8'hff;	  
        8'h48:map_func = 8'hff;	  
        8'h49:map_func = 8'hff;	  
        8'h4a:map_func = 8'hff;	  
        8'h4b:map_func = 8'hff;	  
        8'h4c:map_func = 8'hff; 
        8'h4d:map_func = 8'hff;	  
        8'h4e:map_func = 8'hff;	  
        8'h4f:map_func = 8'hff;	 
        8'h50:map_func = 8'hff;	 
        8'h51:map_func = 8'hff;	  
        8'h52:map_func = 8'hff;	  
        8'h53:map_func = 8'hff;	  
        8'h54:map_func = 8'hff;	 
        8'h55:map_func = 8'hff;	  
        8'h56:map_func = 8'hff;	  
        8'h57:map_func = 8'hff;	  
        8'h58:map_func = 8'hff;	  
        8'h59:map_func = 8'hff;	  
        8'h5a:map_func = 8'hff;	  
        8'h5b:map_func = 8'hff;	  
        8'h5c:map_func = 8'hff; 
        8'h5d:map_func = 8'hff;	  
        8'h5e:map_func = 8'hff;	  
        8'h5f:map_func = 8'hff;	 
        8'h60:map_func = 8'hff;	 
        8'h61:map_func = 8'hff;	  
        8'h62:map_func = 8'hff;	  
        8'h63:map_func = 8'hff;	  
        8'h64:map_func = 8'hff;	 
        8'h65:map_func = 8'hff;	  
        8'h66:map_func = 8'hff;	  
        8'h67:map_func = 8'hff;	  
        8'h68:map_func = 8'hff;	  
        8'h69:map_func = 8'hff;	  
        8'h6a:map_func = 8'hff;	  
        8'h6b:map_func = 8'hff;	  
        8'h6c:map_func = 8'hff; 
        8'h6d:map_func = 8'hff;	  
        8'h6e:map_func = 8'hff;	  
        8'h6f:map_func = 8'hff;	 
        8'h70:map_func = 8'hff;	 
        8'h71:map_func = 8'hff;	  
        8'h72:map_func = 8'hff;	  
        8'h73:map_func = 8'hff;	  
        8'h74:map_func = 8'hff;	 
        8'h75:map_func = 8'hff;	  
        8'h76:map_func = 8'hff;	  
        8'h77:map_func = 8'hff;	  
        8'h78:map_func = 8'hff;	  
        8'h79:map_func = 8'hff;	  
        8'h7a:map_func = 8'hff;	  
        8'h7b:map_func = 8'hff;	  
        8'h7c:map_func = 8'hff; 
        8'h7d:map_func = 8'hff;	  
        8'h7e:map_func = 8'hff;	  
        8'h7f:map_func = 8'hff;	 
        8'h90:map_func = 8'hff;	 
        8'h91:map_func = 8'hff;	  
        8'h92:map_func = 8'hff;	  
        8'h93:map_func = 8'hff;	  
        8'h94:map_func = 8'hff;	 
        8'h95:map_func = 8'hff;	  
        8'h96:map_func = 8'hff;	  
        8'h97:map_func = 8'hff;	  
        8'h98:map_func = 8'hff;	  
        8'h99:map_func = 8'hff;	  
        8'h9a:map_func = 8'hff;	  
        8'h9b:map_func = 8'hff;	  
        8'h9c:map_func = 8'hff; 
        8'h9d:map_func = 8'hff;	  
        8'h9e:map_func = 8'hff;	  
        8'h9f:map_func = 8'hff;	  
        8'ha0:map_func = 8'hff;	 
        8'ha1:map_func = 8'hff;	  
        8'ha2:map_func = 8'hff;	  
        8'ha3:map_func = 8'hff;	  
        8'ha4:map_func = 8'hff;	 
        8'ha5:map_func = 8'hff;	  
        8'ha6:map_func = 8'hff;	  
        8'ha7:map_func = 8'hff;	  
        8'ha8:map_func = 8'hff;	  
        8'ha9:map_func = 8'hff;	  
        8'haa:map_func = 8'hff;	  
        8'hab:map_func = 8'hff;	  
        8'hac:map_func = 8'hff; 
        8'had:map_func = 8'hff;	  
        8'hae:map_func = 8'hff;	  
        8'haf:map_func = 8'hff;	  
        8'hb0:map_func = 8'hff;	 
        8'hb1:map_func = 8'hff;	  
        8'hb2:map_func = 8'hff;	  
        8'hb3:map_func = 8'hff;	  
        8'hb4:map_func = 8'hff;	 
        8'hb5:map_func = 8'hff;	  
        8'hb6:map_func = 8'hff;	  
        8'hb7:map_func = 8'hff;	  
        8'hb8:map_func = 8'hff;	  
        8'hb9:map_func = 8'hff;	  
        8'hba:map_func = 8'hff;	  
        8'hbb:map_func = 8'hff;	  
        8'hbc:map_func = 8'hff; 
        8'hbd:map_func = 8'hff;	  
        8'hbe:map_func = 8'hff;	  
        8'hbf:map_func = 8'hff;	  
        8'hc0:map_func = 8'hff;	 
        8'hc1:map_func = 8'hff;	  
        8'hc2:map_func = 8'hff;	  
        8'hc3:map_func = 8'hff;	  
        8'hc4:map_func = 8'hff;	 
        8'hc5:map_func = 8'hff;	  
        8'hc6:map_func = 8'hff;	  
        8'hc7:map_func = 8'hff;	  
        8'hc8:map_func = 8'hff;	  
        8'hc9:map_func = 8'hff;	  
        8'hca:map_func = 8'hff;	  
        8'hcb:map_func = 8'hff;	  
        8'hcc:map_func = 8'hff; 
        8'hcd:map_func = 8'hff;	  
        8'hce:map_func = 8'hff;	  
        8'hcf:map_func = 8'hff;	  
        8'hd0:map_func = 8'hff;	 
        8'hd1:map_func = 8'hff;	  
        8'hd2:map_func = 8'hff;	  
        8'hd3:map_func = 8'hff;	  
        8'hd4:map_func = 8'hff;	 
        8'hd5:map_func = 8'hff;	  
        8'hd6:map_func = 8'hff;	  
        8'hd7:map_func = 8'hff;	  
        8'hd8:map_func = 8'hff;	  
        8'hd9:map_func = 8'hff;	  
        8'hda:map_func = 8'hff;	  
        8'hdb:map_func = 8'hff;	  
        8'hdc:map_func = 8'hff; 
        8'hdd:map_func = 8'hff;	  
        8'hde:map_func = 8'hff;	  
        8'hdf:map_func = 8'hff;	  
        8'he0:map_func = 8'hff;	 
        8'he1:map_func = 8'hff;	  
        8'he2:map_func = 8'hff;	  
        8'he3:map_func = 8'hff;	  
        8'he4:map_func = 8'hff;	 
        8'he5:map_func = 8'hff;	  
        8'he6:map_func = 8'hff;	  
        8'he7:map_func = 8'hff;	  
        8'he8:map_func = 8'hff;	  
        8'he9:map_func = 8'hff;	  
        8'hea:map_func = 8'hff;	  
        8'heb:map_func = 8'hff;	  
        8'hec:map_func = 8'hff; 
        8'hfd:map_func = 8'hff;	  
        8'hfe:map_func = 8'hff;	  
        8'hff:map_func = 8'hff;	  
        8'hf0:map_func = 8'hff;	 
        8'hf1:map_func = 8'hff;	  
        8'hf2:map_func = 8'hff;	  
        8'hf3:map_func = 8'hff;	  
        8'hf4:map_func = 8'hff;	 
        8'hf5:map_func = 8'hff;	  
        8'hf6:map_func = 8'hff;	  
        8'hf7:map_func = 8'hff;	  
        8'hf8:map_func = 8'hff;	  
        8'hf9:map_func = 8'hff;	  
        8'hfa:map_func = 8'hff;	  
        8'hfb:map_func = 8'hff;	  
        8'hfc:map_func = 8'hff; 
        8'hfd:map_func = 8'hff;	  
        8'hfe:map_func = 8'hff;	  
        8'hff:map_func = 8'hff;	 
        default:map_func=8'h00;	 
      endcase
     end
  endfunction	 
  
  //M̃^C~O
  always@(posedge clk)begin
    vsync_o <= vsync;
    hsync_o <= hsync;
	data_out_en <= data_in_en;
  end
  
  //sNZf[^ϊ  
  assign da_gray = (77*data_in_r + 150*data_in_g + 29*data_in_b );
  assign maped_gray = map_func(da_gray[15:8]);
  always@(posedge clk)
    if(rst==1'b1)begin
	  data_out_r <= 8'h00;
	  data_out_g <= 8'h00;
	  data_out_b <= 8'h00;
	end
  else
    case(mode_sw)
	  3'd0:begin
	    data_out_r <= data_in_r;
	    data_out_g <= data_in_g;
	    data_out_b <= data_in_b;
	  end
	  3'd1:begin
	    data_out_r <= da_gray[15:8];
	    data_out_g <= da_gray[15:8];
	    data_out_b <= da_gray[15:8];
	  end
	  3'd2:begin
	    data_out_r <= 8'hff - data_in_r;
	    data_out_g <= 8'hff - data_in_g;
	    data_out_b <= 8'hff - data_in_b;
	  end
	  3'd3:begin
	    data_out_r <= {1'b0,data_in_r[7:1]};
	    data_out_g <= {1'b0,data_in_g[7:1]};
	    data_out_b <= {1'b0,data_in_b[7:1]};
	  end
	  3'd4:begin
	    data_out_r <= data_in_r;
	    data_out_g <= 8'h00;
	    data_out_b <= 8'h00;
	  end
	  3'd5:begin
	    data_out_r <= 8'h00;
	    data_out_g <= data_in_g;
	    data_out_b <= 8'h00;
	  end
	  3'd6:begin	   
        data_out_r <= 8'h00;
	    data_out_g <= 8'h00;
	    data_out_b <= data_in_b;
	  end
	  3'd7:begin	   
        data_out_r <= maped_gray;
	    data_out_g <= maped_gray;
	    data_out_b <= maped_gray;
	  end
	  default:begin
	    data_out_r <= data_in_r;
	    data_out_g <= data_in_g;
	    data_out_b <= data_in_b;
	  end
    endcase
  
	assign  vga_hsync = (vga_sel==1'b0)?hsync:hsync_o;
	assign  vga_vsync = (vga_sel==1'b0)?vsync:vsync_o;
	assign  vga_r = (vga_sel==1'b0)?data_in_r:data_out_r;
	assign  vga_g = (vga_sel==1'b0)?data_in_g:data_out_g;
	assign  vga_b = (vga_sel==1'b0)?data_in_b:data_out_b;
	assign  vga_en = (vga_sel==1'b0)?data_in_en:data_out_en;
endmodule


