`timescale 1ns / 1ps
//date 2015/04/21 yokomizo
module hdmi_to_vga_hdmi
   (
    clk,
    reset,
    data_in_from_pins_n,
    data_in_from_pins_p,
    diff_clk_in_clk_n,
    diff_clk_in_clk_p,
    //   
        TMDS_clk_n,
        TMDS_clk_p,
        TMDS_data_n,
        TMDS_data_p,
        pmod_hdmi_hpd,
	//
	scl,sda,
	m_scl,m_sda,
	hdmi_out_en,hdmi_hpd,
	hsync, vsync, red_da, green_da, blue_da,
    led,
    led2,
    i2c_led,
    mon_hsync,mon_vsync,mon_data,
	mon_pclk,
	mode_sw,
	vga_sel
	);
  input clk;
  input reset;
  input [2:0]data_in_from_pins_n;
  input [2:0]data_in_from_pins_p;
  input diff_clk_in_clk_n;
  input diff_clk_in_clk_p;
  output TMDS_clk_n;
  output TMDS_clk_p;
  output [2:0]TMDS_data_n;
  output [2:0]TMDS_data_p;
  output  pmod_hdmi_hpd;
  input      scl; 
  inout      sda;
  output      m_scl; 
  inout      m_sda;
  output  hdmi_out_en;
  output  hdmi_hpd;
output        hsync;               // horizontal sync
output        vsync;               // vertical sync
output [ 4:0] red_da; // RGB color signals
output [ 5:0] green_da; // RGB color signals
output [ 4:0] blue_da; // RGB color signals
output       led;
output led2;
output i2c_led;
output mon_hsync;
output mon_vsync;
output [3:0]  mon_data;
output        mon_pclk;
input [2:0]mode_sw;
input vga_sel;

  wire [2:0]bitslip;
  wire clk_div_out;
  wire [2:0]data_in_from_pins_n;
  wire [2:0]data_in_from_pins_p;
  wire [29:0]data_in_to_device;
  wire diff_clk_in_clk_n;
  wire diff_clk_in_clk_p;

    /////////////////////////
  wire rx0_pclk, rx0_pclkx2, rx0_pclkx10, rx0_pllclk0;
  wire rx0_plllckd;
  wire rx0_reset;
  wire rx0_serdesstrobe;
  wire rx0_hsync;          // hsync data
  wire rx0_vsync;          // vsync data
  wire rx0_de;             // data enable
  wire rx0_psalgnerr;      // channel phase alignment error
  wire [7:0] rx0_red;      // pixel data out
  wire [7:0] rx0_green;    // pixel data out
  wire [7:0] rx0_blue;     // pixel data out
  wire [29:0] rx0_sdata;
  wire rx0_blue_vld;
  wire rx0_green_vld;
  wire rx0_red_vld;
  wire rx0_blue_rdy;
  wire rx0_green_rdy;
  wire rx0_red_rdy;
  wire rxclk;
  
  reg [23:0]cnt;
  reg led;

  wire [29:0] data_out_from_device;
  wire [23:0]RGB_data;
  reg [23:0]cnt2;
  reg   mon_hsync;
  reg   mon_vsync;
  reg [9:0]  mon_data;
  reg [9:0]  data_0_d;
  reg [9:0]  data_1_d;
  reg [9:0]  data_2_d;
  wire [9:0] data_10b_r;
  wire [9:0] data_10b_g;
  wire [9:0] data_10b_b;
  
  wire clk_x5;
  wire [7:0] hdmi_r;
  wire [7:0] hdmi_g;
  wire [7:0] hdmi_b;
  wire hdmi_vsync;
  wire hdmi_hsync;
  wire hdmi_de;
  wire [7:0] vga_r;
  wire [7:0] vga_g;
  wire [7:0] vga_b;
  wire vga_vsync;
  wire vga_hsync;
  wire vga_de;
  //assign bitslip = 0;
  assign hdmi_out_en = 1'b0;
  assign hdmi_hpd = 1'b1;
  
  assign pmod_hdmi_hpd = 1'b0;
 // assign RGB_data={rx0_blue,rx0_green,rx0_red};
  
  assign RGB_data={rx0_red,rx0_blue,rx0_green};
  /*
dvi_dec dvi_dec_i
       (.bitslip(bitslip),
        .clk_dvi_out(rxclk),
        .data_in_from_pins_n(data_in_from_pins_n),
        .data_in_from_pins_p(data_in_from_pins_p),
        .data_in_to_device(data_in_to_device),
		.data_out_from_device(data_out_from_device),
        .CLK_IN1_D_clk_n(diff_clk_in_clk_n),
        .CLK_IN1_D_clk_p(diff_clk_in_clk_p),
        .data_out_to_pins_n(TMDS_data_n),
        .data_out_to_pins_p(TMDS_data_p),
        .diff_clk_to_pins_clk_n(TMDS_clk_n),
        .diff_clk_to_pins_clk_p(TMDS_clk_p),
        .io_reset(reset));
*/		
		
hdmi_in_sp	hdmi_in_sp_i
       (.bitslip(bitslip),
        .clk_out1(rxclk),
        .data_in_from_pins_n(data_in_from_pins_n),
        .data_in_from_pins_p(data_in_from_pins_p),
        .data_in_to_device(data_in_to_device),
		//.data_out_from_device(data_out_from_device),
        .CLK_IN1_D_clk_n(diff_clk_in_clk_n),
        .CLK_IN1_D_clk_p(diff_clk_in_clk_p),
        //.data_out_to_pins_n(TMDS_data_n),
        //.data_out_to_pins_p(TMDS_data_p),
        //.diff_clk_to_pins_clk_n(TMDS_clk_n),
        //.diff_clk_to_pins_clk_p(TMDS_clk_p),		
        .clk_out2(clk_x5),
        .reset(reset),
		.reset_unlock(reset_unlock));
		
		
		
hdmi_out_ps	hdmi_out_ps_i
       (.clk_div_in(rxclk),
        .clk_in(clk_x5),
        .clk_reset(reset_unlock),
		.data_out_from_device(data_out_from_device),
        .data_out_to_pins_n(TMDS_data_n),
        .data_out_to_pins_p(TMDS_data_p),
        .diff_clk_to_pins_clk_n(TMDS_clk_n),
        .diff_clk_to_pins_clk_p(TMDS_clk_p),
        .io_reset(reset_unlock));
		
	wire [9:0] data_0;
	wire [9:0] data_1;
	wire [9:0] data_2;
	
    assign data_0 = {data_in_to_device[27],
	                  data_in_to_device[24],
	                  data_in_to_device[21],
	                  data_in_to_device[18],
	                  data_in_to_device[15],
	                  data_in_to_device[12],
	                  data_in_to_device[9],
	                  data_in_to_device[6],
	                  data_in_to_device[3],
	                  data_in_to_device[0]}	;
					  
    assign data_1 = {data_in_to_device[28],
	                  data_in_to_device[25],
	                  data_in_to_device[22],
	                  data_in_to_device[19],
	                  data_in_to_device[16],
	                  data_in_to_device[13],
	                  data_in_to_device[10],
	                  data_in_to_device[7],
	                  data_in_to_device[4],
	                  data_in_to_device[1]}	;
					  
    assign data_2 = {data_in_to_device[29],
	                  data_in_to_device[26],
	                  data_in_to_device[23],
	                  data_in_to_device[20],
	                  data_in_to_device[17],
	                  data_in_to_device[14],
	                  data_in_to_device[11],
	                  data_in_to_device[8],
	                  data_in_to_device[5],
	                  data_in_to_device[2]}	;		  
	
	hdmi_to_rgb hdmi_to_rgb (
	.rxclk(rxclk),
	.data_in(data_in_to_device), 
    .exrst       (reset),
    .hsync       (rx0_hsync),
    .vsync       (rx0_vsync),
    .de          (rx0_de),
    .red         (rx0_red),
    .green       (rx0_green),
    .blue        (rx0_blue),
	.bitslip(bitslip)
	); 

/*	
  gazou_syori gazou_syori_i
       (.hdmi_clk(rxclk),
        .hdmi_return(hdmi_return),
        .da_b_i(rx0_red),
        .da_g_i(rx0_green),
        .da_r_i(rx0_blue),
        .mode_sw(mode_sw));

	assign mode_sw ={4'b000,sw};
	assign hdmi_r = hdmi_return[7:0];
	assign hdmi_g = hdmi_return[15:8];
	assign hdmi_b = hdmi_return[23:16];
*/
 gazou_syori gazou_syori_i
       (.clk(rxclk),
	    .rst(reset),
        .data_in_r(rx0_red),
        .data_in_g(rx0_green),
        .data_in_b(rx0_blue),
		.data_in_en(rx0_de),
		.vsync(rx0_vsync),
		.hsync(rx0_hsync),
        .data_out_r(hdmi_r),
        .data_out_g(hdmi_g),
        .data_out_b(hdmi_b),
		.data_out_en(hdmi_de),
		.vsync_o(hdmi_vsync),
		.hsync_o(hdmi_hsync),
        .vga_r(vga_r),
        .vga_g(vga_g),
        .vga_b(vga_b),
		.vga_en(vga_de),
		.vga_vsync(vga_vsync),
		.vga_hsync(vga_hsync),
        .mode_sw(mode_sw),
		.vga_sel(vga_sel));

	/*	
	assign  hsync = hdmi_hsync;
	assign  vsync = hdmi_vsync;
	assign  red_da = (hdmi_de==1'b0)?5'b00000:hdmi_r[7:3];
	assign  green_da = (hdmi_de==1'b0)?6'b000000:hdmi_g[7:2];
	assign  blue_da = (hdmi_de==1'b0)?5'b00000:hdmi_b[7:3];
	*/
  vga_out vga_out_i
       (.clk(rxclk),
	    .reset(reset),
		.vsync_i(vga_vsync),
		.hsync_i(vga_hsync),
        .red_da_i(vga_r),
        .green_da_i(vga_g),
        .blue_da_i(vga_b),
		.de_i(vga_de),
		.vsync(vsync),
		.hsync(hsync),
        .red_da(red_da),
        .green_da(green_da),
        .blue_da(blue_da));

wire sda_o;
wire i2c_led;

        i2c_trc_top i2c_trc_top (
                .clk(clk), 
                .rst(reset), 
                .s_scl(scl), 
				.s_sda(sda),
                .m_scl(m_scl),  
                .m_sda(m_sda),
				.led(i2c_led)
        ) ;
	

	
	always@(posedge clk)
	  if(reset==1'b1)
        cnt <= 24'd0;
      else
        cnt <= cnt + 24'd1;

	always@(posedge rxclk)
	  if(reset==1'b1)
        cnt2 <= 24'd0;
      else
        cnt2 <= cnt2 + 24'd1;

    assign led2 = cnt2[23];		
	
	always@(posedge clk)
	begin
	  mon_hsync <= rx0_hsync;
	  mon_vsync <= rx0_vsync;
	  mon_data <={red_da,blue_da};
	 end
	  
	always@(posedge rxclk)
	begin	 
	  data_0_d <= data_0;
	  data_1_d <= data_1;
	  data_2_d <= data_2;	  
	end
	
	always@(posedge clk)
	  led <= ((^data_0_d)^(^data_1_d)^(^data_2_d))&cnt[23] & (^rx0_blue);
	  
	reg [3:0]mon_clk_cnt; 
 
    always@(posedge rx0_pclk)
      if(reset==1'b1)
        mon_clk_cnt <= 4'd0;
      else
        if(mon_clk_cnt==4'd9)	  
          mon_clk_cnt <= 4'd0;
		else
          mon_clk_cnt <= mon_clk_cnt + 4'd1;
		  
	assign mon_pclk =mon_clk_cnt[3];
 
    rgb_to_hdmi rgb_to_hdmi(
     .clk(     rxclk),
     .rst(     reset),
     .data_in_r( hdmi_r),
     .data_in_g( hdmi_g),
     .data_in_b( hdmi_b),
     .data_in_en( hdmi_de),
     .vsync(   hdmi_vsync),
     .hsync(   hdmi_hsync),
     .data_out(data_out_from_device));
	 
	/*
   enc_sync enc_sync_r(
     .clk(     rxclk),
     .rst(     reset),
     .data_in( rx0_red),
     .data_in_en( rx0_de),
     .vsync(   rx0_vsync),
     .hsync(   rx0_hsync),
     .data_out(data_10b_r)
    );
	
   enc_sync enc_sync_g(
     .clk(     rxclk),
     .rst(     reset),
     .data_in( rx0_green),
     .data_in_en( rx0_de),
     .vsync(   rx0_vsync),
     .hsync(   rx0_hsync),
     .data_out(data_10b_g)
    );
	
   enc_sync enc_sync_b(
     .clk(     rxclk),
     .rst(     reset),
     .data_in( rx0_blue),
     .data_in_en( rx0_de),
     .vsync(   rx0_vsync),
     .hsync(   rx0_hsync),
     .data_out(data_10b_b)
    );

	assign data_out_from_device ={
	  data_10b_r[9],
	  data_10b_g[9],
	  data_10b_b[9],
	  data_10b_r[8],
	  data_10b_g[8],
	  data_10b_b[8],
	  data_10b_r[7],
	  data_10b_g[7],
	  data_10b_b[7],
	  data_10b_r[6],
	  data_10b_g[6],
	  data_10b_b[6],
	  data_10b_r[5],
	  data_10b_g[5],
	  data_10b_b[5],
	  data_10b_r[4],
	  data_10b_g[4],
	  data_10b_b[4],
	  data_10b_r[3],
	  data_10b_g[3],
	  data_10b_b[3],
	  data_10b_r[2],
	  data_10b_g[2],
	  data_10b_b[2],
	  data_10b_r[1],
	  data_10b_g[1],
	  data_10b_b[1],
	  data_10b_r[0],
	  data_10b_g[0],
	  data_10b_b[0]
	};
	*/
endmodule


