`timescale 1ns / 1ps
//date 2016/04/21 yokomizo
module rgb_to_hdmi(
  input  wire       clk,
  input  wire       rst,
  input  wire [7:0] data_in_r,
  input  wire [7:0] data_in_g,
  input  wire [7:0] data_in_b,
  input  wire       data_in_en,
  input  wire       vsync,
  input  wire       hsync,
  output wire [29:0] data_out
);
  	  
wire [9:0]data_10b_r;
wire [9:0]data_10b_g;
wire [9:0]data_10b_b;

   tmds_enc tmds_enc_r(
     .clk(     clk),
     .rst(     rst),
     .data_in( data_in_r),
     .data_in_en( data_in_en),
     .vsync(   1'b0),
     .hsync(   1'b0),
     .data_out(data_10b_r)
    );
	
   tmds_enc tmds_enc_g(
     .clk(     clk),
     .rst(     rst),
     .data_in( data_in_g),
     .data_in_en( data_in_en),
     .vsync(   1'b0),
     .hsync(   1'b0),
     .data_out(data_10b_g)
    );
	
   tmds_enc tmds_enc_b(
     .clk(     clk),
     .rst(     rst),
     .data_in( data_in_b),
     .data_in_en( data_in_en),
     .vsync(   vsync),
     .hsync(   hsync),
     .data_out(data_10b_b)
    );

	assign data_out ={
	  data_10b_r[9],
	  data_10b_g[9],
	  data_10b_b[9],
	  data_10b_r[8],
	  data_10b_g[8],
	  data_10b_b[8],
	  data_10b_r[7],
	  data_10b_g[7],
	  data_10b_b[7],
	  data_10b_r[6],
	  data_10b_g[6],
	  data_10b_b[6],
	  data_10b_r[5],
	  data_10b_g[5],
	  data_10b_b[5],
	  data_10b_r[4],
	  data_10b_g[4],
	  data_10b_b[4],
	  data_10b_r[3],
	  data_10b_g[3],
	  data_10b_b[3],
	  data_10b_r[2],
	  data_10b_g[2],
	  data_10b_b[2],
	  data_10b_r[1],
	  data_10b_g[1],
	  data_10b_b[1],
	  data_10b_r[0],
	  data_10b_g[0],
	  data_10b_b[0]
	};
endmodule


