`timescale 1 ns / 1ps
//date 2016/04/21 yokomizo
module tmds_enc(
  input  wire       clk,
  input  wire       rst,
  input  wire [7:0] data_in,
  input  wire       data_in_en,
  input  wire       vsync,
  input  wire       hsync,
  output  reg [9:0] data_out
);

  parameter CTRLTOKEN0 = 10'b1101010100; //VSYNC,HSYNC
  parameter CTRLTOKEN1 = 10'b0010101011; //VSYNC
  parameter CTRLTOKEN2 = 10'b0101010100; //HSYNC
  parameter CTRLTOKEN3 = 10'b1010101011; //


  reg vsync_d1;
  reg hsync_d1;
  reg data_in_en_d1;
  reg vsync_d2;
  reg hsync_d2;
  reg data_in_en_d2;
  reg [7:0]data_in_d1;
  wire [9:0] da_c;
  reg [9:0] da_c_d2;
  
  wire [8:0]da_a;
  wire da_a7,da_a6,da_a5,da_a4,da_a3,da_a2,da_a1,da_a0;
  wire [8:0]da_b;
  wire da_b7,da_b6,da_b5,da_b4,da_b3,da_b2,da_b1,da_b0;
  wire [8:0]data_c;
  reg [3:0] bit1_sum_d1;//bit1_sum
  wire [3:0] c_b1_sum_d1;//bit1_sum_da_c 
  reg [3:0] c_b1_sum_d2; 
  reg [3:0] c_b0_sum_d2;
  wire balance_d2;
  wire unbalance_d2;
  wire [9:0] q_out_2;
  wire [4:0]b0s_sub_b1s_d2;
  wire [4:0] b01_cnt_d2;
  reg [4:0] b01_cnt_d3;

  always@(posedge clk)begin
    data_in_d1 <=data_in;
    bit1_sum_d1 =(data_in[7]+data_in[6]+data_in[5]+data_in[4]+data_in[3]+data_in[2]+data_in[1]+data_in[0]); 
  end
  //ϊ
  assign da_a0 = data_in_d1[0];
  assign da_a1 = da_a0^data_in_d1[1];
  assign da_a2 = da_a1^data_in_d1[2];
  assign da_a3 = da_a2^data_in_d1[3];
  assign da_a4 = da_a3^data_in_d1[4];
  assign da_a5 = da_a4^data_in_d1[5];
  assign da_a6 = da_a5^data_in_d1[6];
  assign da_a7 = da_a6^data_in_d1[7];
  assign da_a8 = 1'b1;
  assign da_a ={da_a8,da_a7,da_a6,da_a5,da_a4,da_a3,da_a2,da_a1,da_a0};
  
  assign da_b0 = data_in_d1[0];
  assign da_b1 = da_b0~^data_in_d1[1];
  assign da_b2 = da_b1~^data_in_d1[2];
  assign da_b3 = da_b2~^data_in_d1[3];
  assign da_b4 = da_b3~^data_in_d1[4];
  assign da_b5 = da_b4~^data_in_d1[5];
  assign da_b6 = da_b5~^data_in_d1[6];
  assign da_b7 = da_b6~^data_in_d1[7];
  assign da_b8 = 1'b0;
  assign da_b ={da_b8,da_b7,da_b6,da_b5,da_b4,da_b3,da_b2,da_b1,da_b0};
 //1̐ŕI
 assign da_c=((bit1_sum_d1>4'd4)||((bit1_sum_d1==4'd4)&&(data_in_d1[0]==1'b0)))?da_b:da_a;
 //^C~O
 always @ (posedge clk) begin
   vsync_d1 <= vsync;
   hsync_d1 <= hsync;
   data_in_en_d1 <=data_in_en;
   vsync_d2 <= vsync_d1;
   hsync_d2 <= hsync_d1;
   data_in_en_d2 <=data_in_en_d1;
  end
 //ϊ1̐@				   
 assign  c_b1_sum_d1 =(da_c[7]+da_c[6]+da_c[5]+da_c[4]+da_c[3]+da_c[2]+da_c[1]+da_c[0]); 
  
always @ (posedge clk) begin
    c_b1_sum_d2 <= c_b1_sum_d1 ;
    c_b0_sum_d2 <= 4'd8-c_b1_sum_d1 ;
    da_c_d2 <= da_c;
  end
 //01oX̔  
 assign balance_d2 = (( b01_cnt_d3 == 4'd0) ||( c_b1_sum_d2 == 4'd4 ))?1'b1:1'b0;
 assign unbalance_d2 =(((b01_cnt_d3[4]==1'b0)&&( b01_cnt_d3> 4'd0) && (c_b1_sum_d2 > 4'd4)) ||((b01_cnt_d3[4] == 4'd1) && (c_b1_sum_d2 < 4)))?1'b1:0;
  assign b0s_sub_b1s_d2 = c_b0_sum_d2 - c_b1_sum_d2;
 //01JE^ 
 always @ (posedge clk) begin
   if(data_in_en_d2==1'b0)
	 b01_cnt_d3 <=4'd0;
   else if(balance_d2==1'b1)
	 if(da_c_d2[8]==1'b0)
	    b01_cnt_d3 <=b01_cnt_d3 + b0s_sub_b1s_d2;
	 else
	   b01_cnt_d3 <=b01_cnt_d3 - b0s_sub_b1s_d2;
   else if(unbalance_d2==1'b1)
     b01_cnt_d3 <=b01_cnt_d3 + {da_c_d2[8],1'b0}+ b0s_sub_b1s_d2;
   else
     b01_cnt_d3 <=b01_cnt_d3 - {~da_c_d2[8],1'b0}- b0s_sub_b1s_d2;
  end
  //VSYNC,HSYNC,f[^̑I
  always @ (posedge clk) begin
    if(data_in_en_d2==1'b0)
      //VSYNC,HSYNC
	  if((vsync_d2==1'b0)&&(hsync_d2==0))
	    data_out <= CTRLTOKEN0;
      //VSYNC
	  else if((vsync_d2==1'b0)&&(hsync_d2==1))
	    data_out <= CTRLTOKEN1;
      //HSYNC
	  else if((vsync_d2==1'b1)&&(hsync_d2==0))
	    data_out <= CTRLTOKEN2;
      //
	  else
	    data_out <= CTRLTOKEN3;
    else //摜f[^
	  if(balance_d2==1'b1)
	    if(da_c_d2[8]==1'b0)
		   data_out<={~da_c_d2[8],da_c_d2[8],~da_c_d2[7:0]};
	    else
	       data_out<={~da_c_d2[8],da_c_d2[8],da_c_d2[7:0]};
	  else if(unbalance_d2==1'b1)
        data_out <={1'b1,da_c_d2[8],~da_c_d2[7:0]} ;
 	  else
        data_out <={1'b0,da_c_d2[8],da_c_d2[7:0]};
  end
  
endmodule
