`timescale 1ns / 1ps
//date 2016/04/21 yokomizo
module vga_out
   (
    clk,
    reset,
	hsync_i, vsync_i, red_da_i, green_da_i, blue_da_i,de_i,
	hsync, vsync, red_da, green_da, blue_da
	);
  input clk;
  input reset;
  input        hsync_i;               // horizontal sync
  input        vsync_i;               // vertical sync
  input [ 7:0] red_da_i; // RGB color signals
  input [ 7:0] green_da_i; // RGB color signals
  input [ 7:0] blue_da_i; // RGB color signals
  input        de_i;
  output        hsync;               // horizontal sync
  output        vsync;               // vertical sync
  output [ 4:0] red_da; // RGB color signals
  output [ 5:0] green_da; // RGB color signals
  output [ 4:0] blue_da; // RGB color signals
  
  reg        hsync;               // horizontal sync
  reg        vsync;               // vertical sync
  reg [ 4:0] red_da; // RGB color signals
  reg [ 5:0] green_da; // RGB color signals
  reg [ 4:0] blue_da; // RGB color signals
  
		
  always@(posedge clk)
	if(reset==1'b1)begin
	  hsync<= 1'b1;
	  vsync<= 1'b1;
	  red_da <= 5'b00000;
	  green_da <= 6'b000000;
	  blue_da <= 5'b00000;
	end
	else begin
	  hsync<= hsync_i;
	  vsync<= vsync_i;
	  if(de_i==1'b1)begin
 	    red_da <= red_da_i[7:3];
	    green_da <= green_da_i[7:2];
	    blue_da <= blue_da_i[7:3];
	  end
	  else begin
 	    red_da <= 5'b00000;
	    green_da <= 5'b00000;
	    blue_da <= 5'b00000;
	  end
	end

endmodule


